///* -*- mode: Java; c-basic-offset: 4; indent-tabs-mode: nil; -*-  //------100-columns-wide------>|*/
///*
// * Copyright (c) 2002-2004 Extreme! Lab, Indiana University. All rights reserved.
// *
// * This software is open source. See the bottom of this file for the license.
// *
// * $Id: PuretlsInvoker.java,v 1.3 2007/01/27 00:08:00 aslom Exp $
// */
//
//package xsul.invoker.puretls;
//
//import COM.claymoresystems.ptls.SSLContext;
//import COM.claymoresystems.sslg.SSLPolicyInt;
//import java.io.IOException;
//import java.security.cert.X509Certificate;
//import org.globus.gsi.GlobusCredential;
//import xsul.MLogger;
//import xsul.XsulException;
//import xsul.http_client.ClientSocketFactory;
//import xsul.http_client.HttpClientConnectionManager;
//import xsul.http_client.HttpClientReuseLastConnectionManager;
//import xsul.invoker.DynamicInfosetInvokerException;
//import xsul.invoker.soap_over_http.SoapHttpDynamicInfosetInvoker;
//import xsul.puretls_client_socket_factory.PuretlsClientSocketFactory;
//
///**
// * @version $Revision: 1.3 $
// * @author Satoshi Shirasuna [mailto:sshirasu@cs.indiana.edu]
// * @author Alek
// */
//public class PuretlsInvoker extends SoapHttpDynamicInfosetInvoker {
//    private MLogger logger = MLogger.getLogger();
//
//    protected HttpClientConnectionManager connMgr;
//
//    protected GlobusCredential globusCred = null;
//
//    protected X509Certificate[] trustedCerts = null;
//
//    public PuretlsInvoker(String certKeyFile, String password,
//            String trustedCertsFile) throws XsulException {
//        this(createServiceContext(certKeyFile, password, trustedCertsFile));
//    }
//
//    public PuretlsInvoker(SSLContext ctx) throws XsulException {
//        if (ctx == null) throw new IllegalArgumentException();
//        ClientSocketFactory clientSocketFactory = new PuretlsClientSocketFactory(ctx);
//        connMgr = HttpClientReuseLastConnectionManager.newInstance(clientSocketFactory);
//        setSecureConnectionManager(connMgr);
//        setKeepAlive(true);
//    }
//
//    public static SSLContext createServiceContext(String certKeyFile, String password,
//            String trustedCertsFile) {
//        SSLContext ctx = new SSLContext();
//        try {
//            ctx.loadRootCertificates(trustedCertsFile);
//        } catch (Exception e) {
//            throw new DynamicInfosetInvokerException(
//                    "could not load trusted certificates from: " + trustedCertsFile + " : " + e, e);
//        }
//        if(certKeyFile != null) {
//            try {
//                ctx.loadEAYKeyFile(certKeyFile, password);
//            } catch (IOException e) {
//                throw new DynamicInfosetInvokerException(
//                        "could not load service key and certificate from: " + certKeyFile + " " + e, e);
//            }
//        }
//        SSLPolicyInt policy = new SSLPolicyInt();
//        // if(cipherSuites != null) {
//        // policy.setCipherSuites(cipherSuites);
//        // }
//        policy.negotiateTLS(true);
//        policy.waitOnClose(true);
//        //CertVerifyPolicyInt certPolicy = PureTLSUtil.getDefaultCertVerifyPolicy();
//        //policy.setCertVerifyPolicy(certPolicy);
//        ctx.setPolicy(policy);
//        return ctx;
//    }
//
//}
//
///*
// * Indiana University Extreme! Lab Software License, Version 1.2
// *
// * Copyright (c) 2002-2004 The Trustees of Indiana University. All rights reserved.
// *
// * Redistribution and use in source and binary forms, with or without modification, are permitted
// * provided that the following conditions are met:
// *
// * 1) All redistributions of source code must retain the above copyright notice, the list of authors
// * in the original source code, this list of conditions and the disclaimer listed in this license;
// *
// * 2) All redistributions in binary form must reproduce the above copyright notice, this list of
// * conditions and the disclaimer listed in this license in the documentation and/or other materials
// * provided with the distribution;
// *
// * 3) Any documentation included with all redistributions must include the following
// * acknowledgement:
// *
// * "This product includes software developed by the Indiana University Extreme! Lab. For further
// * information please visit http://www.extreme.indiana.edu/"
// *
// * Alternatively, this acknowledgment may appear in the software itself, and wherever such
// * third-party acknowledgments normally appear.
// *
// * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall not be used to
// * endorse or promote products derived from this software without prior written permission from
// * Indiana University. For written permission, please contact http://www.extreme.indiana.edu/.
// *
// * 5) Products derived from this software may not use "Indiana University" name nor may "Indiana
// * University" appear in their name, without prior written permission of the Indiana University.
// *
// * Indiana University provides no reassurances that the source code provided does not infringe the
// * patent or any other intellectual property rights of any other entity. Indiana University
// * disclaims any liability to any recipient for claims brought by any other entity based on
// * infringement of intellectual property rights or otherwise.
// *
// * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO WARRANTIES AS TO CAPABILITIES
// * OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATION THAT
// * SOFTWARE IS FREE OF INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
// * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS", "VIRUSES", "TROJAN
// * HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE. LICENSEE ASSUMES THE ENTIRE RISK AS TO THE
// * PERFORMANCE OF SOFTWARE AND/OR ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
// * INFORMATION GENERATED USING SOFTWARE.
// */
//
