///* -*- mode: Java; c-basic-offset: 4; indent-tabs-mode: nil; -*-  //------100-columns-wide------>|*/
///* Copyright (c) 2004 Extreme! Lab, Indiana University. All rights reserved.
// * This software is open source. See the bottom of this file for the license.
// * $Id: HttpsPuretlsBasedServices.java,v 1.6 2007/02/22 00:35:05 aslom Exp $ */
//package xsul.xservo_soap_https_puretls;
//
//import COM.claymoresystems.ptls.SSLContext;
//import COM.claymoresystems.sslg.SSLPolicyInt;
//import java.io.IOException;
//import java.security.AccessControlException;
//import java.security.AccessController;
//import java.security.PrivilegedAction;
//import java.security.cert.X509Certificate;
//import org.xmlpull.v1.builder.XmlInfosetBuilder;
//import xsul.MLogger;
//import xsul.XmlConstants;
//import xsul.http_server.HttpMiniServer;
//import xsul.http_server.HttpServerException;
//import xsul.http_server.HttpServerRequest;
//import xsul.http_server.HttpServerResponse;
//import xsul.http_server.ServerSocketFactory;
//import xsul.processor.DynamicInfosetProcessorException;
//import xsul.puretls_server_socket_factory.PuretlsServerSocketFactory;
//import xsul.xservo.XServiceServo;
//import xsul.xservo_soap_http.HttpBasedServices;
//
///**
// * This class provides services over HTTPS (TLS/SS) using PureTLS.
// */
//public class HttpsPuretlsBasedServices extends HttpBasedServices implements XServiceServo {
//    //C=US, ST=Indiana, L=Bloomington, O=Indiana University, OU=Computer Science, CN=anonymous
//    private final static String ANONYMOUS = "anonymous";
//    public final static String SERVICES_ACCEPT_ANONYMOUS_PROPERTY
//    = "services.accept.anonymous";
//    private static final MLogger logger = MLogger.getLogger();
//
//    private final static XmlInfosetBuilder builder = XmlConstants.BUILDER;
//
//    private static boolean defaultAcceptAnonymous = false;
//    private boolean acceptAnonymous = defaultAcceptAnonymous;
//
//    static {
//        initializeAcceptAnon();
//    }
//
//    private static synchronized void initializeAcceptAnon()
//    {
//        String acceptAnonProp = null;
//        try {
//            acceptAnonProp = (String) AccessController.doPrivileged(new PrivilegedAction() {
//                        public Object run() {
//                            return System.getProperty(SERVICES_ACCEPT_ANONYMOUS_PROPERTY);
//                        }
//                    });
//        } catch(AccessControlException ace) {
//            logger.severe("could not read system property "+SERVICES_ACCEPT_ANONYMOUS_PROPERTY, ace);
//        }
//
//        if(acceptAnonProp != null) {
//            try {
//                defaultAcceptAnonymous = Boolean.valueOf(acceptAnonProp);
//                logger.config(SERVICES_ACCEPT_ANONYMOUS_PROPERTY+"="+defaultAcceptAnonymous);
//            } catch(Exception e) {
//                logger.severe("user specified -D"+SERVICES_ACCEPT_ANONYMOUS_PROPERTY+" is not valid", e);
//            }
//        } else {
//            logger.config("no "+SERVICES_ACCEPT_ANONYMOUS_PROPERTY+" property was provided");
//        }
//    }
//
//    /**
//     * Create secure TLS/SSL server that uses following files for security
//     *
//     * @param serverPort
//     *            tcp port (0 will find first available)
//     * @param hostcertsKeyFile
//     *            file must have both private key and service certificate chain (minimum one cert)
//     * @param password
//     *            use empty string (not null) for key files without password
//     * @param trustedCertsFile
//     *            file must have concatenated root certificates
//     * @throws DynamicInfosetProcessorException
//     */
//    public HttpsPuretlsBasedServices(int serverPort, String hostcertsKeyFile, String password,
//            String trustedCertsFile) throws DynamicInfosetProcessorException {
//        if (serverPort == -1) {
//            serverPort = 443;
//        }
//        SSLContext ctx = createContext(hostcertsKeyFile, password, trustedCertsFile);
//        ServerSocketFactory secureSocketFactory = new PuretlsServerSocketFactory(serverPort, ctx);
//        HttpMiniServer miniServer = new HttpMiniServer(secureSocketFactory);
//        setServer(miniServer);
//        init();
//    }
//
//    public HttpsPuretlsBasedServices(ServerSocketFactory secureSocketFactory) throws DynamicInfosetProcessorException {
//        HttpMiniServer miniServer = new HttpMiniServer(secureSocketFactory);
//        setServer(miniServer);
//        init();
//    }
//
//    public HttpsPuretlsBasedServices(HttpMiniServer miniServer) throws DynamicInfosetProcessorException {
//        setServer(miniServer);
//        init();
//    }
//
//    protected SSLContext createContext(String certKeyFile, String password, String trustedCertsFile) {
//        return createServiceContext(certKeyFile, password, trustedCertsFile);
//    }
//
//    public static SSLContext createServiceContext(String certKeyFile,
//            String password, String trustedCertsFile) {
//
//        // PureTLSContext ctx = new PureTLSContext(); // new SSLContext();
//        SSLContext ctx = new SSLContext();
//        try {
//            ctx.loadRootCertificates(trustedCertsFile);
//            // ctx.setTrustedCertificates(trustedCerts);
//            // Vector list = new Vector();
//            // for (int i=0;i<trustedCerts.length;i++) {
//            // list.addElement(certs[i].getEncoded());
//            // }
//            // ctx.setRootList(list)
//        } catch (Exception e) {
//            throw new DynamicInfosetProcessorException(
//                    "could not load trusted certificates from '"+trustedCertsFile+"': " + e, e);
//        }
//        if(certKeyFile != null) {
//            try {
//                ctx.loadEAYKeyFile(certKeyFile, password);
//            } catch (IOException e) {
//                throw new DynamicInfosetProcessorException(
//                        "could load service cert and key from '"+certKeyFile+"':" + e, e);
//            }
//        }
//        SSLPolicyInt policy = new SSLPolicyInt();
//        // if(cipherSuites != null) {
//        // policy.setCipherSuites(cipherSuites);
//        // }
//        policy.requireClientAuth(true);
//        policy.setAcceptNoClientCert(true);
//        ctx.setPolicy(policy);
//        return ctx;
//    }
//
//    protected void init() {
//        try {
//            start();
//        } catch (IOException e) {
//            throw new DynamicInfosetProcessorException("could not start server", e);
//        }
//    }
//
//    /**
//     * Before calling XML processing check that request use SSL/TLS client authentication
//     */
//    public void serviceXml(HttpServerRequest req, HttpServerResponse res)
//    throws HttpServerException
//    {
//        if(!req.isSecure()){
//            throw new HttpServerException("SSL/TLS is required to access this service.");
//        }
//        if(!HttpServerRequest.CLIENT_CERT_AUTH.equals(req.getAuthType()) ) {
//            throw new HttpServerException("SSL/TLS client authentication is required to access this service.");
//        }
//        java.security.cert.X509Certificate certs[] =
//            (X509Certificate[] )req.getAttribute(HttpServerRequest.ATTR_X509_CERTS);
//        //for (int i = 0; i < certs.length; i++) {
//        String dn = certs[0].getSubjectDN().toString();
//        if(logger.isFinerEnabled()){
//            logger.finer("SSL/TLS connection client cert dn="+dn);
//        }
//        if(dn.indexOf(ANONYMOUS) != -1) {
//            if(!acceptAnonymous) {
//                throw new HttpServerException(
//                        "SSL/TLS client authentication with "+ANONYMOUS
//                        +" in DN is not allowed to access this service.");
//            }
//        }
//
//        super.serviceXml(req, res);
//    }
//
//    public boolean isAcceptAnonymous() {
//        return acceptAnonymous;
//    }
//
//    public void setAcceptAnonymous(boolean acceptAnonymous) {
//        this.acceptAnonymous = acceptAnonymous;
//    }
//
//
//}
//
///*
// * Indiana University Extreme! Lab Software License, Version 1.2
// *
// * Copyright (c) 2002-2004 The Trustees of Indiana University. All rights reserved.
// *
// * Redistribution and use in source and binary forms, with or without modification, are permitted
// * provided that the following conditions are met:
// *
// * 1) All redistributions of source code must retain the above copyright notice, the list of authors
// * in the original source code, this list of conditions and the disclaimer listed in this license;
// *
// * 2) All redistributions in binary form must reproduce the above copyright notice, this list of
// * conditions and the disclaimer listed in this license in the documentation and/or other materials
// * provided with the distribution;
// *
// * 3) Any documentation included with all redistributions must include the following
// * acknowledgement:
// *
// * "This product includes software developed by the Indiana University Extreme! Lab. For further
// * information please visit http://www.extreme.indiana.edu/"
// *
// * Alternatively, this acknowledgment may appear in the software itself, and wherever such
// * third-party acknowledgments normally appear.
// *
// * 4) The name "Indiana University" or "Indiana University Extreme! Lab" shall not be used to
// * endorse or promote products derived from this software without prior written permission from
// * Indiana University. For written permission, please contact http://www.extreme.indiana.edu/.
// *
// * 5) Products derived from this software may not use "Indiana University" name nor may "Indiana
// * University" appear in their name, without prior written permission of the Indiana University.
// *
// * Indiana University provides no reassurances that the source code provided does not infringe the
// * patent or any other intellectual property rights of any other entity. Indiana University
// * disclaims any liability to any recipient for claims brought by any other entity based on
// * infringement of intellectual property rights or otherwise.
// *
// * LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO WARRANTIES AS TO CAPABILITIES
// * OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATION THAT
// * SOFTWARE IS FREE OF INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
// * INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS", "VIRUSES", "TROJAN
// * HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE. LICENSEE ASSUMES THE ENTIRE RISK AS TO THE
// * PERFORMANCE OF SOFTWARE AND/OR ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
// * INFORMATION GENERATED USING SOFTWARE.
// */
//
